Bug 666409 - Review Request: t4k_common - Library for Tux4Kids applications
Summary: Review Request: t4k_common - Library for Tux4Kids applications
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
low
medium
Target Milestone: ---
Assignee: Martin Gieseking
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-12-30 15:02 UTC by Gwyn Ciesla
Modified: 2011-09-30 18:50 UTC (History)
4 users (show)

Fixed In Version: t4k_common-0.1.1-2.fc16
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-09-25 03:50:57 UTC
martin.gieseking: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Gwyn Ciesla 2010-12-30 15:02:32 UTC
Description:
library of code shared by tuxmath, tuxtype, and
possibly other tux4kids apps in the future.


SPEC: http://zanoni.jcomserv.net/fedora/t4k_common/t4k_common.spec
SRPM: http://zanoni.jcomserv.net/fedora/t4k_common/t4k_common-0.0.3-1.fc14.src.rpm

Needed to upgrade tuxmath to 1.9.0.

Comment 1 Brendan Jones 2011-02-23 11:39:47 UTC
Hi Jon,

I've put together an informal review for you here. Comments denoted by ***

Great project.

+ OK
- N/A
! Problem
? Not evaluated

Required
=========
[+] rpmlint must be run on the source rpm and all binary rpms the build produces

rpmlint ../RPMS/x86_64/t4k_common-*
t4k_common.x86_64: W: spelling-error %description -l en_US tuxmath -> tux math, tux-math, Tuxtla
t4k_common.x86_64: W: spelling-error %description -l en_US tuxtype -> tux type, tux-type, Tuxtla
t4k_common.x86_64: W: shared-lib-calls-exit /usr/lib64/libt4k_common.so.0.0.0 exit@GLIBC_2.2.5
t4k_common-devel.x86_64: W: spelling-error %description -l en_US tuxmath -> tux math, tux-math, Tuxtla
t4k_common-devel.x86_64: W: spelling-error %description -l en_US tuxtype -> tux type, tux-type, Tuxtla
3 packages and 0 specfiles checked; 0 errors, 5 warnings.

rpmlint ../SRPMS/t4k_common-0.0.3-1.fc14.src.rpm
t4k_common.src: W: spelling-error %description -l en_US tuxmath -> tux math, tux-math, Tuxtla
t4k_common.src: W: spelling-error %description -l en_US tuxtype -> tux type, tux-type, Tuxtla
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

[+] named according to the Package Naming Guidelines 
    *** upstream package contains an underscore, so this is ok
[+] The spec file name must match the base package %{name}, in the format %{name}.spec 
[+] Meet the Packaging Guidelines
    *** NOTE: no longer need %clean/cleaning of the buildroot in %install unless building for F12 and below  or EPEL   
[+] Be licensed with a Fedora approved license and meet the Licensing Guidelines 
[+] The License field in the package spec file must match the actual license
[+] License file must be included in %doc
[+] The spec file must be written in American English
[+] The spec file for the package MUST be legible
[+] The sources used to build the package must match the upstream source
[+] Successfully compile and build into binary rpms on at least one primary architecture
[+] Proper use of ExcludeArch 
[+] All build dependencies must be listed in BuildRequires
[+] The spec file MUST handle locales properly
[+] Shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun
[+] Packages must NOT bundle copies of system libraries
[-] If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package
[!] A package must own all directories that it creates
    *** line 54: must own %{_datadir}/%{name} - do not need to qualify files or directories under this
[+] A Fedora package must not list a file more than once in the spec file's %files listings
[+] Permissions on files must be set properly. Every %files section must include a %defattr(...) line
[!] Each package must consistently use macros
    *** use %{name} macro in Source0
[+] The package must contain code, or permissable content
[+] Large documentation files must go in a -doc subpackage
[+] If a package includes something as %doc, it must not affect the runtime of the application
[+] Header files must be in a -devel package
[-] Static libraries must be in a -static package
[+] library files that end in .so (without suffix) must go in a -devel package
[+] devel packages must require the base package using a fully versioned dependency
[+] Packages must NOT contain any .la libtool archives
[-] GUI apps must include a %{name}.desktop file, properly installed with desktop-file-install in the %install section 
[+] Packages must not own files or directories already owned by other packages
[+] All filenames in rpm packages must be valid UTF-8

Should Items
============
[-] the packager SHOULD query upstream for any missing license text files to include it
[-] Non-English language support for description and summary sections in the package spec if available
[+] The reviewer should test that the package builds in mock
[+] The package should compile and build into binary rpms on all supported architectures
[?] The reviewer should test that the package functions as described
[+] If scriptlets are used, those scriptlets must be sane
[?] Usually, subpackages other than devel should require the base package using a fully versioned dependency
[+] The placement of pkgconfig(.pc) should usually be placed in a -devel pkg
[-] If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself
[-] Should contain man pages for binaries/scripts
    *** no man pages in upstream package



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 3 Martin Gieseking 2011-02-23 14:56:52 UTC
(In reply to comment #1)
> [+] Meet the Packaging Guidelines
>     *** NOTE: no longer need %clean/cleaning of the buildroot in %install
> unless building for F12 and below  or EPEL   

Right. F12 has reached end of life, so we don't have to care about it any longer. The buildroot stuff is still required for EPEL < 6. Jon, if you intend to keep it, please adapt the BuildRoot field according to
http://fedoraproject.org/wiki/EPEL/GuidelinesAndPolicies#BuildRoot_tag


> [+] The sources used to build the package must match the upstream source

That's OK. Brendan, please copy the md5sums of the tarballs into your reviews so that we can easily verify the identity. 

$ md5sum t4k_common-0.0.3.tar.gz*
28ad0818aa79d701fd33019e756340f8  t4k_common-0.0.3.tar.gz
28ad0818aa79d701fd33019e756340f8  t4k_common-0.0.3.tar.gz.upstream


> [!] A package must own all directories that it creates
>     *** line 54: must own %{_datadir}/%{name} - do not need to qualify files or
> directories under this

Yes, %{_datadir}/%{name} is currently unowned. Either replace 
%{_datadir}/%{name}/images with %{_datadir}/%{name}/ 
or add %dir %{_datadir}/%{name}


> [+] Permissions on files must be set properly. Every %files section must
> include a %defattr(...) line

The %defattrs should look like this: %defattr(-,root,root,-)


> [!] Each package must consistently use macros
>     *** use %{name} macro in Source0

OK, but using %{name} in Source0 is optional.


Some additional notes:
- you should preserve the timestamps by adding INSTALL='install -p' to
  "make install"

- drop INSTALL as it's not of much use in a binary package

- move README to the base package, and also add file ChangeLog

- please be more specific in %files especially when only single files/folders 
  are added, e.g.:
  %{_libdir}/*.so.* => %{_libdir}/lib%{name}.so.*
  %{_libdir}/*.so   => %{_libdir}/lib%{name}.so
  %{_includedir}/*  => %{_includedir}/%{name}.h

- if you want to use the %{name} macro in the %files section, please add the
  .pc file with %{_libdir}/pkgconfig/%{name}.pc

- I suggest to also build the API docs (with doxygen) and add the HTML variant 
  to the -devel package

Comment 5 Martin Gieseking 2011-07-18 16:58:32 UTC
Here's the formal review. Sorry for the delay, I've been pretty busy lately.

The package looks allmost fine. Here are a few things that need some attention:
- The .pc file is packaged twice. Drop it from the base package.
- As the files generated by doxygen contain devel docs, move them to the 
  devel package.
- I recommend to set the proper file permissions in %install and use 
  %defattr(-,root,root,-) in %files
- drop doxygen/html/installdox as it's not required
- Please use the original CamelCase spelling from upstream in the 
  %description: TuxMath, TuxType, Tux4Kids

$ rpmlint *.rpm
t4k_common.src: W: spelling-error %description -l en_US tuxmath -> tux math, tux-math, bathmat
t4k_common.src: W: spelling-error %description -l en_US tuxtype -> tux type, tux-type, Teletype
t4k_common.x86_64: W: spelling-error %description -l en_US tuxmath -> tux math, tux-math, bathmat
t4k_common.x86_64: W: spelling-error %description -l en_US tuxtype -> tux type, tux-type, Teletype
t4k_common.x86_64: W: shared-lib-calls-exit /usr/lib64/libt4k_common.so.0.0.0 exit@GLIBC_2.2.5
t4k_common.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/t4k_common.pc
t4k_common.x86_64: W: doc-file-dependency /usr/share/doc/t4k_common-0.0.3/html/installdox /usr/bin/perl
t4k_common-devel.x86_64: W: spelling-error %description -l en_US tuxmath -> tux math, tux-math, bathmat
t4k_common-devel.x86_64: W: spelling-error %description -l en_US tuxtype -> tux type, tux-type, Teletype
t4k_common-devel.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 10 warnings.

---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license.
    - GPLv3+

[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: The file containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source.
    $ md5sum t4k_common-0.0.3.tar.gz*
    28ad0818aa79d701fd33019e756340f8  t4k_common-0.0.3.tar.gz
    28ad0818aa79d701fd33019e756340f8  t4k_common-0.0.3.tar.gz.1

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, ...
[+] MUST: All build dependencies must be listed in BuildRequires.
[+] MUST: When compiling C, C++, or Fortran files, %{optflags} must be applied.
[.] MUST: The spec file MUST handle locales properly.
[.] MUST: If a package installs files below %{_datadir}/icons, the icon cache must be updated.
[+] MUST: Packages storing shared library files (not just symlinks) must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, ...
[+] MUST: A package must own all directories that it creates. 
[X] MUST: A Fedora package must not list a file more than once in %files.
    - the .pc file is packaged twice (base and devel package)

[+] MUST: Permissions on files must be set properly.
[.] MUST: Packages must not provide RPM dependency information when that information is not global in nature, or are otherwise handled.
[.] MUST: When filtering automatically generated RPM dependency information, the filtering system implemented by Fedora must be used.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage.
[+] MUST: Files in %doc must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: .so files with a suffix must go in a -devel package.
[+] MUST: devel packages must require the base package using a fully versioned dependency.
[+] MUST: Packages must NOT contain any .la libtool archives.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

EPEL <= 5 only:
[+] MUST: The spec file must contain a valid BuildRoot field.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot}.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'

[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream
[+] SHOULD: Timestamps of files should be preserved.
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The reviewer should test that the package functions as described.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[+] SHOULD: pkgconfig(.pc) files should be placed in a -devel pkg.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: Your package should contain man pages for binaries/scripts.

Comment 6 Gwyn Ciesla 2011-07-18 17:37:10 UTC
Thanks!  Issues above addressed, and an update to latest upstream.

SPEC: http://zanoni.jcomserv.net/fedora/t4k_common/t4k_common.spec
SRPM:
http://zanoni.jcomserv.net/fedora/t4k_common/t4k_common-0.1.1-1.fc15.src.rpm

Comment 7 Martin Gieseking 2011-07-18 18:22:05 UTC
OK, there are still some issues, sorry. Please recheck the source archives as that in the SRPM differs from the upstream one:

$ md5sum t4k_common-0.1.1.tar.gz*
e3d5da74971f427e8deb1e904dfcf8ab  t4k_common-0.1.1.tar.gz
28ad0818aa79d701fd33019e756340f8  t4k_common-0.1.1.tar.gz.1

- Also, swap the %defattr and %doc lines in %files devel.

- The latest tarball bundles liblinebreak (in src/linebreak). As linking of
  bundled libraries is not permitted, please adapt the sources to use the 
  liblinebreak package from the Fedora repo.

- Think about dropping doxygen/html/installdox. It's an installation script not
  required by the user. Removing this file will also make rpmlint happy.


$ rpmlint *.rpm
t4k_common.src: W: file-size-mismatch t4k_common-0.1.1.tar.gz = 629215, https://alioth.debian.org/frs/download.php/3439/t4k_common-0.1.1.tar.gz = 575582
t4k_common.x86_64: W: shared-lib-calls-exit /usr/lib64/libt4k_common.so.0.0.0 exit@GLIBC_2.2.5
t4k_common-devel.x86_64: W: doc-file-dependency /usr/share/doc/t4k_common-devel-0.1.1/html/installdox /usr/bin/perl
4 packages and 0 specfiles checked; 0 errors, 3 warnings.

Comment 8 Gwyn Ciesla 2011-07-18 18:38:17 UTC
I get e3d5da74971f427e8deb1e904dfcf8ab for both what I built with and a fresh download of wget https://alioth.debian.org/frs/download.php/3540/t4k_common-0.1.1.tar.gz --no-check-certificate

I've fixed everything else, I'll work on the bundled lib.  Thanks, good catch.

Comment 9 Martin Gieseking 2011-07-18 19:07:40 UTC
(In reply to comment #8)
> https://alioth.debian.org/frs/download.php/3540/t4k_common-0.1.1.tar.gz

Ah OK, I downloaded the file from the location given in Source0:
https://alioth.debian.org/frs/download.php/3439/t4k_common-0.1.1.tar.gz

You should update the URL accordingly (3439 -> 3540).

Comment 10 Gwyn Ciesla 2011-07-18 23:24:54 UTC
while(1){ <headdesk> };


I've managed to extract the bundled liblinebreak, only to discover that the implementation in t4k_common was moved over from the tuxmath code, where it had been modified a few times, and was apparently forked from an old version of upstream but I'm not sure which.  There are things that have either been deprecated in the current version or added by the tux4kids devs that t4k_common and tuxmath need.  I can fudge a bit with creative #defines, but there are entire functions missing.

This seems like a good candidate for a bundling exception.  I'll file the trac with FPC.  I'm on the FPC, and will obviously have to recuse myself for this vote.

Comment 11 Gwyn Ciesla 2011-07-18 23:30:34 UTC
https://fedorahosted.org/fpc/ticket/98

Comment 12 Gwyn Ciesla 2011-09-14 15:29:49 UTC
FPC exception granted, updated accordingly.

SPEC: http://zanoni.jcomserv.net/fedora/t4k_common/t4k_common.spec
SRPM:
http://zanoni.jcomserv.net/fedora/t4k_common/t4k_common-0.1.1-1.fc15.src.rpm

Thanks for your patience.

Comment 13 Martin Gieseking 2011-09-14 16:16:16 UTC
OK, great. The package is ready now. Please add %{?_isa} to Requires: %{name} = %{version}-%{release} as requested by the recent version of the guidelines [1] before you check-in the package.

[1] http://fedoraproject.org/wiki/PackagingGuidelines#Requiring_Base_Package

----------------
Package APPROVED
----------------

Comment 14 Gwyn Ciesla 2011-09-14 16:23:17 UTC
Excellent, will do, thanks!


New Package SCM Request
=======================
Package Name: t4k_common
Short Description: Library for Tux4Kids applications
Owners: limb
Branches: f16 f15
InitialCC:

Comment 15 Gwyn Ciesla 2011-09-14 16:28:12 UTC
Git done (by process-git-requests).

Comment 16 Fedora Update System 2011-09-14 16:51:15 UTC
t4k_common-0.1.1-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/t4k_common-0.1.1-2.fc16

Comment 17 Fedora Update System 2011-09-14 16:51:23 UTC
t4k_common-0.1.1-2.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/t4k_common-0.1.1-2.fc15

Comment 18 Fedora Update System 2011-09-14 22:39:54 UTC
t4k_common-0.1.1-2.fc15 has been pushed to the Fedora 15 testing repository.

Comment 19 Fedora Update System 2011-09-25 03:50:49 UTC
t4k_common-0.1.1-2.fc15 has been pushed to the Fedora 15 stable repository.

Comment 20 Fedora Update System 2011-09-30 18:50:04 UTC
t4k_common-0.1.1-2.fc16 has been pushed to the Fedora 16 stable repository.


Note You need to log in before you can comment on or make changes to this bug.